using System;
using System.Buffers;
using System.Text;
using WingInterfaceLibrary.Notifications;
using System.Text.Json;
using  System.IO;

namespace WingNotificationModule.Adapter
{
    public class BufferAdapter
    {
        private object _message;
        public BufferAdapter(object message)
        {
            _message = message;
        }

        /// <summary>
        /// 获取消息字节流
        /// </summary>
        /// <returns></returns>
        public byte[] GetMessageBuffer()
        {
            ArrayBufferWriter<byte> bufferWriter = new ArrayBufferWriter<byte>();
            //  bufferWriter.Write(GetNotificationTypeBytes());
             bufferWriter.Write(GetMessageBytes().Span);
            return bufferWriter.WrittenSpan.ToArray();
        }

        // private byte[] GetNotificationTypeBytes()
        // {
        //     var notificationTypeValue = (byte)_message.NotificationType;
        //     return new byte[] { notificationTypeValue };
        // }

        private ReadOnlyMemory<byte> GetMessageBytes()
        {
            ArrayBufferWriter<byte> bufferWriter = new ArrayBufferWriter<byte>();
         //   var messageBuffer = Encoding.UTF8.GetBytes(_message.Message);
           using var stream = new MemoryStream();
            JsonSerializer.SerializeAsync(stream, _message);
            var messageBuffer =  stream.ToArray();
            // var lenBytes = BitConverter.GetBytes(messageBuffer.Length);
            // bufferWriter.Write(lenBytes);
            bufferWriter.Write(messageBuffer);
            return bufferWriter.WrittenMemory;
        }
    }
}