﻿using System;
using System.Net.WebSockets;

namespace WingNotificationModule.Channel.WebSocket
{
    public class WebSocketMessage
    {
        /// <summary>
        /// buffer
        /// </summary>
        public ArraySegment<byte> Buffer { get; }

        //
        // 摘要:
        //     Indicates whether the current message is a UTF-8 message or a binary message.
        //
        // 返回结果:
        //     Returns System.Net.WebSockets.WebSocketMessageType.
        public WebSocketMessageType MessageType { get; }

        public WebSocketMessage(ArraySegment<byte> buffer, WebSocketMessageType messageType)
        {
            Buffer = buffer;
            MessageType = messageType;
        }
    }
}
