﻿using System;

namespace WingNotificationModule.Channel.WebSocket
{
    /// <summary>
    /// WebSocket state
    /// </summary>
    [Flags]
    public enum WebSocketProcessState
    {
        //
        // 摘要:
        //     Reserved for future use.
        None = 1,
        //
        // 摘要:
        //     The connection is negotiating the handshake with the remote endpoint.
        Connecting = 2,
        //
        // 摘要:
        //     The initial state after the HTTP handshake has been completed.
        Open = 4,
        //
        // 摘要:
        //     A close message was sent to the remote endpoint.
        CloseSent = 8,
        //
        // 摘要:
        //     A close message was received from the remote endpoint.
        CloseReceived = 16,
        //
        // 摘要:
        //     Indicates the WebSocket close handshake completed gracefully.
        Closed = 32,
        //
        // 摘要:
        //     Reserved for future use.
        Aborted = 64
    }
}
